Fail to get WWPN on IBM Storwize

Bug #1163754 reported by Jack Wu on 2013-04-03
6
This bug affects 1 person
Affects Status Importance Assigned to Milestone
Cinder
High
Avishay Traeger
Grizzly
High
Avishay Traeger

Bug Description

The Cinder driver uses the command "lsportfc" to get WWPN from IBM Storwize. The command is not supported by Storwize firmware old than 6.4.1. The bug causes following tracing log.

#### /var/log/cinder/volume.log ####
2013-04-02 15:14:43.758 ERROR cinder.volume.drivers.san.san [req-bad4f419-ffc0-4801-bb4e-8ac7f93575d4 None None] Error running SSH command: lsportfc -delim !
2013-04-02 15:14:43.761 26480 CRITICAL cinder [-] Unexpected error while running command.
Command: lsportfc -delim !
Exit code: 127
Stdout: ''
Stderr: 'rbash: lsportfc: command not found\n'
2013-04-02 15:14:43.761 26480 TRACE cinder Traceback (most recent call last):
2013-04-02 15:14:43.761 26480 TRACE cinder   File "/usr/bin/cinder-volume", line 59, in <module>
2013-04-02 15:14:43.761 26480 TRACE cinder     launcher.wait()
2013-04-02 15:14:43.761 26480 TRACE cinder   File "/usr/lib/python2.6/site-packages/cinder/service.py", line 137, in wait
2013-04-02 15:14:43.761 26480 TRACE cinder     service.wait()
2013-04-02 15:14:43.761 26480 TRACE cinder   File "/usr/lib/python2.6/site-packages/eventlet/greenthread.py", line 166, in wait
2013-04-02 15:14:43.761 26480 TRACE cinder     return self._exit_event.wait()
2013-04-02 15:14:43.761 26480 TRACE cinder   File "/usr/lib/python2.6/site-packages/eventlet/event.py", line 116, in wait
2013-04-02 15:14:43.761 26480 TRACE cinder     return hubs.get_hub().switch()
2013-04-02 15:14:43.761 26480 TRACE cinder   File "/usr/lib/python2.6/site-packages/eventlet/hubs/hub.py", line 177, in switch
2013-04-02 15:14:43.761 26480 TRACE cinder     return self.greenlet.switch()
2013-04-02 15:14:43.761 26480 TRACE cinder   File "/usr/lib/python2.6/site-packages/eventlet/greenthread.py", line 192, in main
2013-04-02 15:14:43.761 26480 TRACE cinder     result = function(*args, **kwargs)
2013-04-02 15:14:43.761 26480 TRACE cinder   File "/usr/lib/python2.6/site-packages/cinder/service.py", line 98, in run_server
2013-04-02 15:14:43.761 26480 TRACE cinder     server.start()
2013-04-02 15:14:43.761 26480 TRACE cinder   File "/usr/lib/python2.6/site-packages/cinder/service.py", line 345, in start
2013-04-02 15:14:43.761 26480 TRACE cinder     self.manager.init_host()
2013-04-02 15:14:43.761 26480 TRACE cinder   File "/usr/lib/python2.6/site-packages/cinder/volume/manager.py", line 145, in init_host
2013-04-02 15:14:43.761 26480 TRACE cinder     self.driver.do_setup(ctxt)
2013-04-02 15:14:43.761 26480 TRACE cinder   File "/usr/lib/python2.6/site-packages/cinder/volume/drivers/storwize_svc.py", line 248, in do_setup
2013-04-02 15:14:43.761 26480 TRACE cinder     self._get_fc_wwpns()
2013-04-02 15:14:43.761 26480 TRACE cinder   File "/usr/lib/python2.6/site-packages/cinder/volume/drivers/storwize_svc.py", line 166, in _get_fc_wwpns
2013-04-02 15:14:43.761 26480 TRACE cinder     header = next(generator, None)
2013-04-02 15:14:43.761 26480 TRACE cinder   File "/usr/lib/python2.6/site-packages/cinder/volume/drivers/storwize_svc.py", line 1351, in _port_conf_generator
2013-04-02 15:14:43.761 26480 TRACE cinder     out, err = self._run_ssh(ssh_cmd)
2013-04-02 15:14:43.761 26480 TRACE cinder   File "/usr/lib/python2.6/site-packages/cinder/volume/drivers/san/san.py", line 152, in _run_ssh
2013-04-02 15:14:43.761 26480 TRACE cinder     raise e
2013-04-02 15:14:43.761 26480 TRACE cinder ProcessExecutionError: Unexpected error while running command.
2013-04-02 15:14:43.761 26480 TRACE cinder Command: lsportfc -delim !
2013-04-02 15:14:43.761 26480 TRACE cinder Exit code: 127
2013-04-02 15:14:43.761 26480 TRACE cinder Stdout: ''
2013-04-02 15:14:43.761 26480 TRACE cinder Stderr: 'rbash: lsportfc: command not found\n'
2013-04-02 15:14:43.761 26480 TRACE cinder

Changed in cinder:
status: New → Confirmed
assignee: nobody → Avishay Traeger (avishay-il)
tags: added: drivers storwize-svc
tags: added: grizzly-backport-potential
Changed in cinder:
importance: Undecided → High

Fix proposed to branch: master
Review: https://review.openstack.org/26587

Changed in cinder:
status: Confirmed → In Progress

Reviewed: https://review.openstack.org/26587
Committed: http://github.com/openstack/cinder/commit/f38f943899ea95fe237be1d096ceafd35b57a843
Submitter: Jenkins
Branch: master

commit f38f943899ea95fe237be1d096ceafd35b57a843
Author: Avishay Traeger <email address hidden>
Date: Wed Apr 10 11:24:45 2013 +0300

    Fix incompatible Storwize/SVC commands.

    Inconsistencies in the command line syntax between Storwize/SVC
    models and firmware versions caused driver failures. This patch
    makes commands compatible to fix driver crashes on the V3700 and
    controllers with firmware version 6.3.

    Change-Id: I51d5b97afa5419cdbf488f9e4e4597d22bb22f20
    Fixes: bug 1163754
    Fixed: bug 1163964

Changed in cinder:
status: In Progress → Fix Committed
tags: removed: grizzly-backport-potential
Thierry Carrez (ttx) on 2013-05-29
Changed in cinder:
milestone: none → havana-1
status: Fix Committed → Fix Released

Reviewed: https://review.openstack.org/26815
Committed: http://github.com/openstack/cinder/commit/c27f0747965be98b33d4a18fe78dfeaf5a0c1cc6
Submitter: Jenkins
Branch: stable/grizzly

commit c27f0747965be98b33d4a18fe78dfeaf5a0c1cc6
Author: Avishay Traeger <email address hidden>
Date: Fri May 31 07:55:02 2013 +0300

    Fix incompatible Storwize/SVC commands.

    Inconsistencies in the command line syntax between Storwize/SVC
    models and firmware versions caused driver failures. This patch
    makes commands compatible to fix driver crashes on the V3700 and
    controllers with firmware version 6.3.

    Cherry-picked from f38f943899ea95fe237be1d096ceafd35b57a843

    Change-Id: I51d5b97afa5419cdbf488f9e4e4597d22bb22f20
    Fixes: bug 1163754
    Fixed: bug 1163964

tags: added: in-stable-grizzly
Alan Pevec (apevec) on 2013-08-06
tags: removed: in-stable-grizzly
Thierry Carrez (ttx) on 2013-10-17
Changed in cinder:
milestone: havana-1 → 2013.2
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers